#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Money]",
	author	= "wS",
	version = "1.1.1"
};

enum VipModule
{
	money_kill= 0,
	money_headshot,
	money_knife,
	money_c4plant,
	money_c4defus,
	money_hostage,
	money_spawnset,
	money_spawnadd
};

new const String:ITEM_NAME[][] = 
{
	"money_kill",
	"money_headshot",
	"money_knife",
	"money_c4plant",
	"money_c4defus",
	"money_hostage",
	"money_spawnset",
	"money_spawnadd"
};

new g_bAccess[MAXPLAYERS + 1][VipModule];
new g_ItemID[VipModule];

new g_MaxMoney = 16000;

public OnPluginStart()
{
	///
	new bool:ok = false;
	new Handle:kv = CreateKeyValues("money");
	if (FileToKeyValues(kv, "cfg/vip/modules/money/money.txt"))
	{
		for (new VipModule:module; module < VipModule; module++)
		{
			if (KvGetNum(kv, ITEM_NAME[module]) == 1)
			{
				if (!(g_ItemID[module] = VIP_RegisterItem(ITEM_NAME[module], VIP_ITEM_TOGGLE)))
					SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME[module]);
				ok = true;
			}
		}
	}
	CloseHandle(kv);
	if (!ok) SetFailState("Check cfg/vip/modules/money/money.txt");
	///
	
	LoadTranslations("vip_modules_description.phrases");

	new Handle:hCvar = FindConVar("mp_maxmoney");
	if (hCvar != INVALID_HANDLE)
	{
		g_MaxMoney = GetConVarInt(hCvar);
		HookConVarChange(hCvar, cvar_maxmoney);
	}

	if (g_ItemID[money_kill] || g_ItemID[money_headshot] || g_ItemID[money_knife])
		HookEventEx("player_death", player_death, EventHookMode_Post);
	
	if (g_ItemID[money_c4plant])	HookEventEx("bomb_planted",		bomb_planted,		EventHookMode_Post);
	if (g_ItemID[money_c4defus])	HookEventEx("bomb_defused",		bomb_defused,		EventHookMode_Post);
	if (g_ItemID[money_hostage])	HookEventEx("hostage_rescued",	hostage_rescued,	EventHookMode_Post);
	
	if (g_ItemID[money_spawnset] || g_ItemID[money_spawnadd])
		VIP_HookEvent(VE_Spawn, OnClientSpawn);
}

public cvar_maxmoney(Handle:hCvar, const String:OldValue[], const String:NewValue[])
	g_MaxMoney = StringToInt(NewValue);

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	new VipModule:module = wS_ItemIDToModule(ItemID);
	if (g_bAccess[client][module])
	{
		IntToString(g_bAccess[client][module], ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public bool:VIP_Description(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], String:description[], description_size)
{
	FormatEx(description, description_size, "%T", "money_value", client, StringToInt(ItemValue));
	return true;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	return UpdateAccess(client, ItemValue, wS_ItemIDToModule(ItemID));
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	new VipModule:module = wS_ItemIDToModule(ItemID);
	g_bAccess[client][module] = 0;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME[module], false);
}

stock VipGiveAction:UpdateAccess(client, String:ItemValue[ITEM_INFO_LENGTH], VipModule:module)
{
	if (!ItemValue[0])
		return VGA_ValueNotSpecified;
	
	new value = StringToInt(ItemValue);
	if (!value)
		return VGA_BadValue;
	
	if (value > g_MaxMoney)
		value = g_MaxMoney;
	
	if (value == g_bAccess[client][module])
		return VGA_SameValue;
	
	g_bAccess[client][module] = value;
	
	IntToString(value, ItemValue, ITEM_INFO_LENGTH);
	VIP_NotifyItemStatusChanged(client, ITEM_NAME[module], true, ItemValue, 16);

	return VGA_Continue;
}

///////////////////////////////////////////////////////////////////////////////////

public OnClientDisconnect(client)
{
	for (new VipModule:module; module < VipModule; module++)
		g_bAccess[client][module] = 0;
}

public player_death(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "attacker"));
	if (client > 0 && GetClientTeam(client) != GetClientTeam(GetClientOfUserId(GetEventInt(event, "userid"))))
	{
		if (g_bAccess[client][money_headshot] && GetEventBool(event, "headshot"))
			wS_AddMoney(client, money_headshot);
		
		else if (g_bAccess[client][money_knife])
		{
			decl String:weapon[24];
			GetEventString(event, "weapon", weapon, sizeof(weapon));
			if (!strcmp(weapon, "knife", false))
			{
				wS_AddMoney(client, money_knife);
				return;
			}
		}
		
		if (g_bAccess[client][money_kill])
			wS_AddMoney(client, money_kill);
	}
}

public bomb_planted	  (Handle:event, const String:name[], bool:silent) wS_AddMoney(GetClientOfUserId(GetEventInt(event, "userid")), money_c4plant);
public bomb_defused	  (Handle:event, const String:name[], bool:silent) wS_AddMoney(GetClientOfUserId(GetEventInt(event, "userid")), money_c4defus);
public hostage_rescued(Handle:event, const String:name[], bool:silent) wS_AddMoney(GetClientOfUserId(GetEventInt(event, "userid")), money_hostage);

public OnClientSpawn(client, team)
{
	if (g_bAccess[client][money_spawnset]) SetEntProp(client, Prop_Send, "m_iAccount", g_bAccess[client][money_spawnset]);
	else wS_AddMoney(client, money_spawnadd);
}

stock VipModule:wS_ItemIDToModule(ItemID)
{
	for (new VipModule:module = VipModule:0; module < VipModule; module++)
	{
		if (g_ItemID[module] == ItemID)
			return module;
	}
	return VipModule:0;
}

stock wS_AddMoney(client, VipModule:module)
{
	if (g_bAccess[client][module])
	{
		new money = GetEntProp(client, Prop_Send, "m_iAccount") + g_bAccess[client][module];
		if (money > g_MaxMoney) money = g_MaxMoney;
		else if (money < 0) money = 0;
		SetEntProp(client, Prop_Send, "m_iAccount", money);
	}
}